package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.HashMap;
import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.ASTNode;
import org.eclipse.jdt.internal.compiler.ast.Annotation;
import org.eclipse.jdt.internal.compiler.ast.Expression;
import org.eclipse.jdt.internal.compiler.ast.ExpressionContext;
import org.eclipse.jdt.internal.compiler.ast.FakedTrackingVariable;
import org.eclipse.jdt.internal.compiler.ast.FieldDeclaration;
import org.eclipse.jdt.internal.compiler.ast.IPolyExpression;
import org.eclipse.jdt.internal.compiler.ast.Invocation;
import org.eclipse.jdt.internal.compiler.ast.ParameterizedQualifiedTypeReference;
import org.eclipse.jdt.internal.compiler.ast.Statement;
import org.eclipse.jdt.internal.compiler.ast.TypeReference;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.flow.FlowContext;
import org.eclipse.jdt.internal.compiler.flow.FlowInfo;
import org.eclipse.jdt.internal.compiler.flow.UnconditionalFlowInfo;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;
import org.eclipse.jdt.internal.compiler.impl.Constant;
import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.ImplicitNullAnnotationVerifier;
import org.eclipse.jdt.internal.compiler.lookup.InferenceContext18;
import org.eclipse.jdt.internal.compiler.lookup.InvocationSite;
import org.eclipse.jdt.internal.compiler.lookup.LocalTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.LocalVariableBinding;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.MethodScope;
import org.eclipse.jdt.internal.compiler.lookup.NestedTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedGenericMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.PolyTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.ProblemMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.SourceTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.Substitution;
import org.eclipse.jdt.internal.compiler.lookup.SyntheticArgumentBinding;
import org.eclipse.jdt.internal.compiler.lookup.SyntheticFactoryMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeConstants;
import org.eclipse.jdt.internal.compiler.lookup.TypeVariableBinding;
import org.eclipse.jdt.internal.compiler.util.SimpleLookupTable;

public class AllocationExpression extends Expression implements IPolyExpression, Invocation {
  public TypeReference type;
  
  public Expression[] arguments;
  
  public MethodBinding binding;
  
  MethodBinding syntheticAccessor;
  
  public TypeReference[] typeArguments;
  
  public TypeBinding[] genericTypeArguments;
  
  public FieldDeclaration enumConstant;
  
  protected TypeBinding typeExpected;
  
  public boolean inferredReturnType;
  
  public FakedTrackingVariable closeTracker;
  
  public ExpressionContext expressionContext = ExpressionContext.VANILLA_CONTEXT;
  
  private SimpleLookupTable inferenceContexts;
  
  public HashMap<TypeBinding, MethodBinding> solutionsPerTargetType;
  
  private InferenceContext18 outerInferenceContext;
  
  public boolean argsContainCast;
  
  public TypeBinding[] argumentTypes = Binding.NO_PARAMETERS;
  
  public boolean argumentsHaveErrors = false;
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo) {
    FlowInfo flowInfo1;
    checkCapturedLocalInitializationIfNecessary((ReferenceBinding)this.binding.declaringClass.erasure(), currentScope, flowInfo);
    if (this.arguments != null) {
      boolean analyseResources = (currentScope.compilerOptions()).analyseResourceLeaks;
      boolean hasResourceWrapperType = (analyseResources && 
        this.resolvedType instanceof ReferenceBinding && (
        (ReferenceBinding)this.resolvedType).hasTypeBit(4));
      for (int i = 0, count = this.arguments.length; i < count; i++) {
        UnconditionalFlowInfo unconditionalFlowInfo = 
          this.arguments[i]
          .analyseCode(currentScope, flowContext, flowInfo)
          .unconditionalInits();
        if (analyseResources && !hasResourceWrapperType)
          flowInfo1 = FakedTrackingVariable.markPassedToOutside(currentScope, this.arguments[i], (FlowInfo)unconditionalFlowInfo, flowContext, false); 
        this.arguments[i].checkNPEbyUnboxing(currentScope, flowContext, flowInfo1);
      } 
      analyseArguments(currentScope, flowContext, flowInfo1, this.binding, this.arguments);
    } 
    ReferenceBinding[] thrownExceptions;
    if ((thrownExceptions = this.binding.thrownExceptions).length != 0) {
      if ((this.bits & 0x10000) != 0 && this.genericTypeArguments == null)
        thrownExceptions = currentScope.environment().convertToRawTypes(this.binding.thrownExceptions, true, true); 
      flowContext.checkExceptionHandlers(
          (TypeBinding[])thrownExceptions, 
          (ASTNode)this, 
          (FlowInfo)flowInfo1.unconditionalCopy(), 
          currentScope);
    } 
    if ((currentScope.compilerOptions()).analyseResourceLeaks && FakedTrackingVariable.isAnyCloseable(this.resolvedType))
      FakedTrackingVariable.analyseCloseableAllocation(currentScope, flowInfo1, this); 
    ReferenceBinding declaringClass = this.binding.declaringClass;
    MethodScope methodScope = currentScope.methodScope();
    if ((declaringClass.isMemberType() && !declaringClass.isStatic()) || (
      declaringClass.isLocalType() && !methodScope.isStatic && methodScope.isLambdaScope()))
      currentScope.tagAsAccessingEnclosingInstanceStateOf(this.binding.declaringClass.enclosingType(), false); 
    manageEnclosingInstanceAccessIfNecessary(currentScope, flowInfo1);
    manageSyntheticAccessIfNecessary(currentScope, flowInfo1);
    flowContext.recordAbruptExit();
    return flowInfo1;
  }
  
  public void checkCapturedLocalInitializationIfNecessary(ReferenceBinding checkedType, BlockScope currentScope, FlowInfo flowInfo) {
    if ((checkedType.tagBits & 0x834L) == 2068L && 
      !currentScope.isDefinedInType(checkedType)) {
      NestedTypeBinding nestedType = (NestedTypeBinding)checkedType;
      SyntheticArgumentBinding[] syntheticArguments = nestedType.syntheticOuterLocalVariables();
      if (syntheticArguments != null)
        for (int i = 0, count = syntheticArguments.length; i < count; i++) {
          SyntheticArgumentBinding syntheticArgument = syntheticArguments[i];
          LocalVariableBinding targetLocal;
          if ((targetLocal = syntheticArgument.actualOuterLocalVariable) != null && 
            targetLocal.declaration != null && !flowInfo.isDefinitelyAssigned(targetLocal))
            currentScope.problemReporter().uninitializedLocalVariable(targetLocal, (ASTNode)this); 
        }  
    } 
  }
  
  public Expression enclosingInstance() {
    return null;
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream, boolean valueRequired) {
    cleanUpInferenceContexts();
    if (!valueRequired)
      currentScope.problemReporter().unusedObjectAllocation(this); 
    int pc = codeStream.position;
    MethodBinding codegenBinding = this.binding.original();
    ReferenceBinding allocatedType = codegenBinding.declaringClass;
    codeStream.new_(this.type, (TypeBinding)allocatedType);
    boolean isUnboxing = ((this.implicitConversion & 0x400) != 0);
    if (valueRequired || isUnboxing)
      codeStream.dup(); 
    if (this.type != null) {
      codeStream.recordPositionsFrom(pc, this.type.sourceStart);
    } else {
      codeStream.ldc(String.valueOf(this.enumConstant.name));
      codeStream.generateInlinedValue(this.enumConstant.binding.id);
    } 
    if (allocatedType.isNestedType())
      codeStream.generateSyntheticEnclosingInstanceValues(
          currentScope, 
          allocatedType, 
          enclosingInstance(), 
          (ASTNode)this); 
    generateArguments(this.binding, this.arguments, currentScope, codeStream);
    if (allocatedType.isNestedType())
      codeStream.generateSyntheticOuterArgumentValues(
          currentScope, 
          allocatedType, 
          (ASTNode)this); 
    if (this.syntheticAccessor == null) {
      codeStream.invoke((byte)-73, codegenBinding, null, this.typeArguments);
    } else {
      int i = 0;
      int max = this.syntheticAccessor.parameters.length - codegenBinding.parameters.length;
      for (; i < max; 
        i++)
        codeStream.aconst_null(); 
      codeStream.invoke((byte)-73, this.syntheticAccessor, null, this.typeArguments);
    } 
    if (valueRequired) {
      codeStream.generateImplicitConversion(this.implicitConversion);
    } else if (isUnboxing) {
      codeStream.generateImplicitConversion(this.implicitConversion);
      switch ((postConversionType((Scope)currentScope)).id) {
        case 7:
        case 8:
          codeStream.pop2();
          break;
        default:
          codeStream.pop();
          break;
      } 
    } 
    codeStream.recordPositionsFrom(pc, this.sourceStart);
  }
  
  public TypeBinding[] genericTypeArguments() {
    return this.genericTypeArguments;
  }
  
  public boolean isSuperAccess() {
    return false;
  }
  
  public boolean isTypeAccess() {
    return true;
  }
  
  public void manageEnclosingInstanceAccessIfNecessary(BlockScope currentScope, FlowInfo flowInfo) {
    if ((flowInfo.tagBits & 0x1) != 0)
      return; 
    ReferenceBinding allocatedTypeErasure = (ReferenceBinding)this.binding.declaringClass.erasure();
    if (allocatedTypeErasure.isNestedType() && (
      currentScope.enclosingSourceType().isLocalType() || currentScope.isLambdaSubscope()))
      if (allocatedTypeErasure.isLocalType()) {
        ((LocalTypeBinding)allocatedTypeErasure).addInnerEmulationDependent(currentScope, false);
      } else {
        currentScope.propagateInnerEmulation(allocatedTypeErasure, false);
      }  
  }
  
  public void manageSyntheticAccessIfNecessary(BlockScope currentScope, FlowInfo flowInfo) {
    if ((flowInfo.tagBits & 0x1) != 0)
      return; 
    MethodBinding codegenBinding = this.binding.original();
    ReferenceBinding declaringClass;
    if (codegenBinding.isPrivate() && TypeBinding.notEquals((TypeBinding)currentScope.enclosingSourceType(), (TypeBinding)(declaringClass = codegenBinding.declaringClass)))
      if ((declaringClass.tagBits & 0x10L) != 0L && (currentScope.compilerOptions()).complianceLevel >= 3145728L) {
        codegenBinding.tagBits |= 0x200L;
      } else {
        this.syntheticAccessor = (MethodBinding)((SourceTypeBinding)declaringClass).addSyntheticMethod(codegenBinding, isSuperAccess());
        currentScope.problemReporter().needToEmulateMethodAccess(codegenBinding, (ASTNode)this);
      }  
  }
  
  public StringBuffer printExpression(int indent, StringBuffer output) {
    if (this.type != null)
      output.append("new "); 
    if (this.typeArguments != null) {
      output.append('<');
      int max = this.typeArguments.length - 1;
      for (int j = 0; j < max; j++) {
        this.typeArguments[j].print(0, output);
        output.append(", ");
      } 
      this.typeArguments[max].print(0, output);
      output.append('>');
    } 
    if (this.type != null)
      this.type.printExpression(0, output); 
    output.append('(');
    if (this.arguments != null)
      for (int i = 0; i < this.arguments.length; i++) {
        if (i > 0)
          output.append(", "); 
        this.arguments[i].printExpression(0, output);
      }  
    return output.append(')');
  }
  
  public TypeBinding resolveType(BlockScope scope) {
    boolean isDiamond = (this.type != null && (this.type.bits & 0x80000) != 0);
    CompilerOptions compilerOptions = scope.compilerOptions();
    long sourceLevel = compilerOptions.sourceLevel;
    if (this.constant != Constant.NotAConstant) {
      this.constant = Constant.NotAConstant;
      if (this.type == null) {
        this.resolvedType = (TypeBinding)scope.enclosingReceiverType();
      } else {
        this.resolvedType = this.type.resolveType(scope, true);
      } 
      if (this.type != null) {
        checkIllegalNullAnnotation(scope, this.resolvedType);
        if (this.type instanceof ParameterizedQualifiedTypeReference) {
          ReferenceBinding currentType = (ReferenceBinding)this.resolvedType;
          if (currentType == null)
            return (TypeBinding)currentType; 
          while ((currentType.modifiers & 0x8) == 0 && 
            !currentType.isRawType()) {
            if ((currentType = currentType.enclosingType()) == null) {
              ParameterizedQualifiedTypeReference qRef = (ParameterizedQualifiedTypeReference)this.type;
              for (int i = qRef.typeArguments.length - 2; i >= 0; i--) {
                if (qRef.typeArguments[i] != null) {
                  scope.problemReporter().illegalQualifiedParameterizedTypeAllocation(this.type, this.resolvedType);
                  break;
                } 
              } 
              break;
            } 
          } 
        } 
      } 
      if (this.typeArguments != null) {
        int length = this.typeArguments.length;
        this.argumentsHaveErrors = (sourceLevel < 3211264L);
        this.genericTypeArguments = new TypeBinding[length];
        int i;
        for (i = 0; i < length; i++) {
          TypeReference typeReference = this.typeArguments[i];
          this.genericTypeArguments[i] = typeReference.resolveType(scope, true);
          if (typeReference.resolveType(scope, true) == null)
            this.argumentsHaveErrors = true; 
          if (this.argumentsHaveErrors && typeReference instanceof org.eclipse.jdt.internal.compiler.ast.Wildcard)
            scope.problemReporter().illegalUsageOfWildcard(typeReference); 
        } 
        if (isDiamond) {
          scope.problemReporter().diamondNotWithExplicitTypeArguments(this.typeArguments);
          return null;
        } 
        if (this.argumentsHaveErrors) {
          if (this.arguments != null) {
            int max;
            for (i = 0, max = this.arguments.length; i < max; i++)
              this.arguments[i].resolveType(scope); 
          } 
          return null;
        } 
      } 
      if (this.arguments != null) {
        this.argumentsHaveErrors = false;
        int length = this.arguments.length;
        this.argumentTypes = new TypeBinding[length];
        for (int i = 0; i < length; i++) {
          Expression argument = this.arguments[i];
          if (argument instanceof org.eclipse.jdt.internal.compiler.ast.CastExpression) {
            argument.bits |= 0x20;
            this.argsContainCast = true;
          } 
          argument.setExpressionContext(ExpressionContext.INVOCATION_CONTEXT);
          if ((this.arguments[i]).resolvedType != null)
            scope.problemReporter().genericInferenceError("Argument was unexpectedly found resolved", (InvocationSite)this); 
          this.argumentTypes[i] = argument.resolveType(scope);
          if (argument.resolveType(scope) == null)
            this.argumentsHaveErrors = true; 
        } 
        if (this.argumentsHaveErrors) {
          if (isDiamond)
            return null; 
          if (this.resolvedType instanceof ReferenceBinding) {
            TypeBinding[] pseudoArgs = new TypeBinding[length];
            for (int j = length; --j >= 0;)
              pseudoArgs[j] = (this.argumentTypes[j] == null) ? (TypeBinding)TypeBinding.NULL : this.argumentTypes[j]; 
            this.binding = scope.findMethod((ReferenceBinding)this.resolvedType, TypeConstants.INIT, pseudoArgs, (InvocationSite)this, false);
            if (this.binding != null && !this.binding.isValidBinding()) {
              MethodBinding closestMatch = ((ProblemMethodBinding)this.binding).closestMatch;
              if (closestMatch != null) {
                ParameterizedGenericMethodBinding parameterizedGenericMethodBinding;
                if ((closestMatch.original()).typeVariables != Binding.NO_TYPE_VARIABLES)
                  parameterizedGenericMethodBinding = scope.environment().createParameterizedGenericMethod(closestMatch.original(), null); 
                this.binding = (MethodBinding)parameterizedGenericMethodBinding;
                MethodBinding closestMatchOriginal = parameterizedGenericMethodBinding.original();
                if (closestMatchOriginal.isOrEnclosedByPrivateType() && !scope.isDefinedInMethod(closestMatchOriginal))
                  closestMatchOriginal.modifiers |= 0x8000000; 
              } 
            } 
          } 
          return this.resolvedType;
        } 
      } 
      if (this.resolvedType == null || !this.resolvedType.isValidBinding())
        return null; 
      if (this.type != null && !this.resolvedType.canBeInstantiated()) {
        scope.problemReporter().cannotInstantiate((Expression)this.type, this.resolvedType);
        return this.resolvedType;
      } 
    } 
    if (isDiamond) {
      this.binding = inferConstructorOfElidedParameterizedType((Scope)scope);
      if (this.binding == null || !this.binding.isValidBinding()) {
        scope.problemReporter().cannotInferElidedTypes(this);
        return this.resolvedType = null;
      } 
      if (this.typeExpected == null && compilerOptions.sourceLevel >= 3407872L && this.expressionContext.definesTargetType())
        return (TypeBinding)new PolyTypeBinding(this); 
      this.resolvedType = this.type.resolvedType = (TypeBinding)this.binding.declaringClass;
      resolvePolyExpressionArguments(this, this.binding, this.argumentTypes, scope);
    } else {
      this.binding = findConstructorBinding(scope, this, (ReferenceBinding)this.resolvedType, this.argumentTypes);
    } 
    if (!this.binding.isValidBinding()) {
      if (this.binding.declaringClass == null)
        this.binding.declaringClass = (ReferenceBinding)this.resolvedType; 
      if (this.type != null && !this.type.resolvedType.isValidBinding())
        return null; 
      scope.problemReporter().invalidConstructor((Statement)this, this.binding);
      return this.resolvedType;
    } 
    if ((this.binding.tagBits & 0x80L) != 0L)
      scope.problemReporter().missingTypeInConstructor((ASTNode)this, this.binding); 
    if (isMethodUseDeprecated(this.binding, (Scope)scope, true))
      scope.problemReporter().deprecatedMethod(this.binding, (ASTNode)this); 
    if (checkInvocationArguments(scope, null, this.resolvedType, this.binding, this.arguments, this.argumentTypes, this.argsContainCast, (InvocationSite)this))
      this.bits |= 0x10000; 
    if (this.typeArguments != null && (this.binding.original()).typeVariables == Binding.NO_TYPE_VARIABLES)
      scope.problemReporter().unnecessaryTypeArgumentsForMethodInvocation(this.binding, this.genericTypeArguments, this.typeArguments); 
    if (!isDiamond && this.resolvedType.isParameterizedTypeWithActualArguments())
      checkTypeArgumentRedundancy((ParameterizedTypeBinding)this.resolvedType, scope); 
    if (compilerOptions.isAnnotationBasedNullAnalysisEnabled) {
      if ((this.binding.tagBits & 0x1000L) == 0L)
        (new ImplicitNullAnnotationVerifier(scope.environment(), compilerOptions.inheritNullAnnotations))
          .checkImplicitNullAnnotations(this.binding, null, false, (Scope)scope); 
      if (compilerOptions.sourceLevel >= 3407872L && 
        this.binding instanceof ParameterizedGenericMethodBinding && this.typeArguments != null) {
        TypeVariableBinding[] typeVariables = this.binding.original().typeVariables();
        for (int i = 0; i < this.typeArguments.length; i++)
          this.typeArguments[i].checkNullConstraints((Scope)scope, (Substitution)this.binding, (TypeBinding[])typeVariables, i); 
      } 
    } 
    if (compilerOptions.sourceLevel >= 3407872L && 
      this.binding.getTypeAnnotations() != Binding.NO_ANNOTATIONS)
      this.resolvedType = scope.environment().createAnnotatedType(this.resolvedType, this.binding.getTypeAnnotations()); 
    return this.resolvedType;
  }
  
  void checkIllegalNullAnnotation(BlockScope scope, TypeBinding allocationType) {
    if (allocationType != null) {
      long nullTagBits = allocationType.tagBits & 0x180000000000000L;
      if (nullTagBits != 0L) {
        Annotation annotation = this.type.findAnnotation(nullTagBits);
        if (annotation != null)
          scope.problemReporter().nullAnnotationUnsupportedLocation(annotation); 
      } 
    } 
  }
  
  public boolean isBoxingCompatibleWith(TypeBinding targetType, Scope scope) {
    return isPolyExpression() ? false : isCompatibleWith(scope.boxing(targetType), scope);
  }
  
  public boolean isCompatibleWith(TypeBinding targetType, Scope scope) {
    ReferenceBinding referenceBinding;
    if (this.argumentsHaveErrors || this.binding == null || !this.binding.isValidBinding() || targetType == null || scope == null)
      return false; 
    TypeBinding allocationType = this.resolvedType;
    if (isPolyExpression()) {
      TypeBinding originalExpectedType = this.typeExpected;
      try {
        MethodBinding method = (this.solutionsPerTargetType != null) ? this.solutionsPerTargetType.get(targetType) : null;
        if (method == null) {
          this.typeExpected = targetType;
          method = inferConstructorOfElidedParameterizedType(scope);
          if (method == null || !method.isValidBinding())
            return false; 
        } 
        referenceBinding = method.declaringClass;
      } finally {
        this.typeExpected = originalExpectedType;
      } 
    } 
    return (referenceBinding != null && referenceBinding.isCompatibleWith(targetType, scope));
  }
  
  public MethodBinding inferConstructorOfElidedParameterizedType(Scope scope) {
    if (this.typeExpected != null && this.binding != null) {
      MethodBinding cached = (this.solutionsPerTargetType != null) ? this.solutionsPerTargetType.get(this.typeExpected) : null;
      if (cached != null)
        return cached; 
    } 
    ReferenceBinding genericType = ((ParameterizedTypeBinding)this.resolvedType).genericType();
    ReferenceBinding enclosingType = this.resolvedType.enclosingType();
    ParameterizedTypeBinding allocationType = scope.environment().createParameterizedType(genericType, (TypeBinding[])genericType.typeVariables(), enclosingType);
    MethodBinding factory = scope.getStaticFactory(allocationType, enclosingType, this.argumentTypes, (InvocationSite)this);
    if (factory instanceof ParameterizedGenericMethodBinding && factory.isValidBinding()) {
      MethodBinding methodBinding;
      ParameterizedGenericMethodBinding genericFactory = (ParameterizedGenericMethodBinding)factory;
      this.inferredReturnType = genericFactory.inferredReturnType;
      SyntheticFactoryMethodBinding sfmb = (SyntheticFactoryMethodBinding)factory.original();
      TypeVariableBinding[] constructorTypeVariables = sfmb.getConstructor().typeVariables();
      TypeBinding[] constructorTypeArguments = (constructorTypeVariables != null) ? new TypeBinding[constructorTypeVariables.length] : Binding.NO_TYPES;
      if (constructorTypeArguments.length > 0)
        System.arraycopy(((ParameterizedGenericMethodBinding)factory).typeArguments, (sfmb.typeVariables()).length - constructorTypeArguments.length, 
            constructorTypeArguments, 0, constructorTypeArguments.length); 
      ParameterizedMethodBinding parameterizedMethodBinding = sfmb.applyTypeArgumentsOnConstructor(((ParameterizedTypeBinding)factory.returnType).arguments, constructorTypeArguments, genericFactory.inferredWithUncheckedConversion);
      if (parameterizedMethodBinding instanceof ParameterizedGenericMethodBinding && (scope.compilerOptions()).sourceLevel >= 3407872L)
        if (this.expressionContext == ExpressionContext.INVOCATION_CONTEXT && this.typeExpected == null)
          methodBinding = ParameterizedGenericMethodBinding.computeCompatibleMethod18(parameterizedMethodBinding.shallowOriginal(), this.argumentTypes, scope, (InvocationSite)this);  
      if (this.typeExpected != null)
        registerResult(this.typeExpected, methodBinding); 
      return methodBinding;
    } 
    return null;
  }
  
  public TypeBinding[] inferElidedTypes(Scope scope) {
    ReferenceBinding genericType = ((ParameterizedTypeBinding)this.resolvedType).genericType();
    ReferenceBinding enclosingType = this.resolvedType.enclosingType();
    ParameterizedTypeBinding allocationType = scope.environment().createParameterizedType(genericType, (TypeBinding[])genericType.typeVariables(), enclosingType);
    MethodBinding factory = scope.getStaticFactory(allocationType, enclosingType, this.argumentTypes, (InvocationSite)this);
    if (factory instanceof ParameterizedGenericMethodBinding && factory.isValidBinding()) {
      ParameterizedGenericMethodBinding genericFactory = (ParameterizedGenericMethodBinding)factory;
      this.inferredReturnType = genericFactory.inferredReturnType;
      return ((ParameterizedTypeBinding)factory.returnType).arguments;
    } 
    return null;
  }
  
  public void checkTypeArgumentRedundancy(ParameterizedTypeBinding allocationType, BlockScope scope) {
    TypeBinding[] inferredTypes;
    if (scope.problemReporter().computeSeverity(16778100) == 256 || (scope.compilerOptions()).sourceLevel < 3342336L)
      return; 
    if (allocationType.arguments == null)
      return; 
    if (this.genericTypeArguments != null)
      return; 
    if (this.type == null)
      return; 
    if (this.argumentTypes == Binding.NO_PARAMETERS && this.typeExpected instanceof ParameterizedTypeBinding) {
      ParameterizedTypeBinding expected = (ParameterizedTypeBinding)this.typeExpected;
      if (expected.arguments != null && allocationType.arguments.length == expected.arguments.length) {
        int j;
        for (j = 0; j < allocationType.arguments.length && 
          !TypeBinding.notEquals(allocationType.arguments[j], expected.arguments[j]); j++);
        if (j == allocationType.arguments.length) {
          scope.problemReporter().redundantSpecificationOfTypeArguments((ASTNode)this.type, allocationType.arguments);
          return;
        } 
      } 
    } 
    int previousBits = this.type.bits;
    try {
      this.type.bits |= 0x80000;
      inferredTypes = inferElidedTypes((Scope)scope);
    } finally {
      this.type.bits = previousBits;
    } 
    if (inferredTypes == null)
      return; 
    for (int i = 0; i < inferredTypes.length; i++) {
      if (TypeBinding.notEquals(inferredTypes[i], allocationType.arguments[i]))
        return; 
    } 
    scope.problemReporter().redundantSpecificationOfTypeArguments((ASTNode)this.type, allocationType.arguments);
  }
  
  public void setActualReceiverType(ReferenceBinding receiverType) {}
  
  public void setDepth(int i) {}
  
  public void setFieldIndex(int i) {}
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {
    if (visitor.visit(this, scope)) {
      if (this.typeArguments != null)
        for (int i = 0, typeArgumentsLength = this.typeArguments.length; i < typeArgumentsLength; i++)
          this.typeArguments[i].traverse(visitor, scope);  
      if (this.type != null)
        this.type.traverse(visitor, scope); 
      if (this.arguments != null)
        for (int i = 0, argumentsLength = this.arguments.length; i < argumentsLength; i++)
          this.arguments[i].traverse(visitor, scope);  
    } 
    visitor.endVisit(this, scope);
  }
  
  public void setExpectedType(TypeBinding expectedType) {
    this.typeExpected = expectedType;
  }
  
  public void setExpressionContext(ExpressionContext context) {
    this.expressionContext = context;
  }
  
  public boolean isPolyExpression() {
    return isPolyExpression(this.binding);
  }
  
  public boolean isPolyExpression(MethodBinding method) {
    return ((this.expressionContext == ExpressionContext.ASSIGNMENT_CONTEXT || this.expressionContext == ExpressionContext.INVOCATION_CONTEXT) && 
      this.type != null && (this.type.bits & 0x80000) != 0);
  }
  
  public TypeBinding invocationTargetType() {
    return this.typeExpected;
  }
  
  public boolean statementExpression() {
    return ((this.bits & 0x1FE00000) == 0);
  }
  
  public MethodBinding binding() {
    return this.binding;
  }
  
  public Expression[] arguments() {
    return this.arguments;
  }
  
  public void registerInferenceContext(ParameterizedGenericMethodBinding method, InferenceContext18 infCtx18) {
    if (this.inferenceContexts == null)
      this.inferenceContexts = new SimpleLookupTable(); 
    this.inferenceContexts.put(method, infCtx18);
  }
  
  public void registerResult(TypeBinding targetType, MethodBinding method) {
    if (method != null && method.isConstructor()) {
      if (this.solutionsPerTargetType == null)
        this.solutionsPerTargetType = new HashMap<>(); 
      this.solutionsPerTargetType.put(targetType, method);
    } 
  }
  
  public InferenceContext18 getInferenceContext(ParameterizedMethodBinding method) {
    if (this.inferenceContexts == null)
      return null; 
    return (InferenceContext18)this.inferenceContexts.get(method);
  }
  
  public void cleanUpInferenceContexts() {
    if (this.inferenceContexts == null)
      return; 
    byte b;
    int i;
    Object[] arrayOfObject;
    for (i = (arrayOfObject = this.inferenceContexts.valueTable).length, b = 0; b < i; ) {
      Object value = arrayOfObject[b];
      if (value != null)
        ((InferenceContext18)value).cleanUp(); 
      b++;
    } 
    this.inferenceContexts = null;
    this.outerInferenceContext = null;
    this.solutionsPerTargetType = null;
  }
  
  public ExpressionContext getExpressionContext() {
    return this.expressionContext;
  }
  
  public InferenceContext18 freshInferenceContext(Scope scope) {
    return new InferenceContext18(scope, this.arguments, (InvocationSite)this, this.outerInferenceContext);
  }
}
